#include "default.h"
#include "button.h"

#include "main.h"

/////////////////////////////////////////////////////////////////////////////
////
////    BUTTON CLASS
////
/////////////////////////////////////////////////////////////////////////////

Button::Button()
{
	color = 0;
  //  color = clSilver;             // clSilver, clRed,
    form = CIRCLE;      //default .
}


/////////////////////////////////////////////////////////////////////////////
////
////    FLOOR BUTTON CLASS
////
/////////////////////////////////////////////////////////////////////////////

FloorButton::FloorButton() : Button()
{
    up_button = UNPUSH;	    // 
	down_button = UNPUSH;	//Ʒ  
}

void FloorButton::CancleButton(int kind)
{
    switch(kind)
    {
        case UP:
            up_button = UNPUSH;
            break;
        case DOWN:
            down_button = UNPUSH;
            break;
    }
}

void FloorButton::PushButton(int kind)
{
    switch(kind)
    {
        case UP:
            up_button = PUSH;
            break;
        case DOWN:
            down_button = PUSH;
            break;
    }
}



/////////////////////////////////////////////////////////////////////////////
////
////     ELEVATOR BUTTON CLASS
////
/////////////////////////////////////////////////////////////////////////////

ElevatorButton::ElevatorButton() : Button()
{
    for(int i = 0; i < FLOOR; i++)
        floor_button[i] = UNPUSH;
}

void ElevatorButton::PushButton(int kind)
{
    floor_button[kind - 1] = PUSH;
}

int ElevatorButton::SearchMaxButton(const int f)
{
    int i = f - 1;

    while(i < FLOOR)
    {
        if(floor_button[i] == PUSH)  //ư 
            return i + 1;             // ư 
        else
            i++;
    }

    return false;                     // ư .
}

int ElevatorButton::SearchMinButton(const int f)
{
    int i = f - 1;

    while(i >= 0)
    {
        if(floor_button[i] == PUSH)  //ư 
            return i + 1;             // ư 
        else
            i--;
    }

    return false;                     // ư .
}
