#include <vcl.h>
#include <iostream.h>
#include "main.h"
#include "default.h"
#include "floor.h"


/////////////////////////////////////////////////////////////////////////////
////
////     FLOOR CLASS
////
/////////////////////////////////////////////////////////////////////////////

Floor::Floor()
{
    level = 0;
	wait_count = 0;		// ο
	work_count = 0;		//ϴ ο
}

Floor::~Floor()
{
}

void Floor::FloorEnter(list<Person> &temp)
{
    list<Person>::iterator i = temp.begin();

    while(i != temp.end())
    {
        if((*i).GetGoFloor() == level)      //  
        {
            work.push_back(*i);
			work_count++;		            //ϴ  īƮ
        }
        else
        {
            wait.push_back(*i);
			wait_count++;		            //ϴ  īƮ
            (*i).ShowWeight();
        }
        i++;
    }
}

void Floor::WaitElevator(Elevator *act)
{
	list<Person>::iterator i = wait.begin();

	while(i != wait.end())
	{
		if((*i).GetGoFloor() > level)	//    ̸
		{
			if((*i).IdentifyButton(button, UP) == UNPUSH)	// ʾ
			{
				button.PushButton(UP);
                act->GoFloor(level);      //ش  ġ䱸
			}
		}
		else if((*i).GetGoFloor() < level)	//   Ʒ̸
		{
			if((*i).IdentifyButton(button, DOWN) == UNPUSH)	// ʾ
			{
				button.PushButton(DOWN);
                act->GoFloor(level);     //ش  ġ 䱸
			}
		}
		i++;
	}
}

void Floor::ShowButtonState(void)
{
    if(button.UpButtonState() == PUSH && button.DownButtonState() == PUSH)
    {                                         //, Ʒ ư 
        DrawTriangle(clRed, UP);
        DrawTriangle(clRed, DOWN);
    }
    else if(button.UpButtonState() == PUSH && button.DownButtonState() == UNPUSH)
    {                                         // ư  
        DrawTriangle(clRed, UP);
        DrawTriangle(clBlack, DOWN);
    }
    else if(button.UpButtonState() == UNPUSH && button.DownButtonState() == PUSH)
    {                                        //Ʒ ư  
        DrawTriangle(clBlack, UP);
        DrawTriangle(clRed, DOWN);
    }
    else                                //ư ΰ  ʾ
    {
        DrawTriangle(clBlack, UP);
        DrawTriangle(clBlack, DOWN);
    }
}

void Floor::DrawTriangle(const TColor color, const int dir)
{
    Form1->Canvas->Pen->Color = color;     // 

    if(dir == UP)         // ư
    {                     //    ϴ ͵
        Form1->Canvas->MoveTo(90, FIRST - ((level - 1) * 40));
        Form1->Canvas->LineTo(82, FIRST - ((level - 1) * 40) + 15);
        Form1->Canvas->LineTo(98, FIRST - ((level - 1) * 40) + 15);
        Form1->Canvas->LineTo(90, FIRST - ((level - 1) * 40));
    }
    else if(dir == DOWN)   //Ʒ  ư
    {
        Form1->Canvas->MoveTo(82, FIRST - ((level - 1) * 40) + 19);
        Form1->Canvas->LineTo(90, FIRST - ((level - 1) * 40) + 36);
        Form1->Canvas->LineTo(98, FIRST - ((level - 1) * 40) + 19);
        Form1->Canvas->LineTo(82, FIRST - ((level - 1) * 40) + 19);
    }
}

void Floor::Action(Elevator *act)
{
	list<Person> dir;       //  

    AddWaitElevator();      //ϴ   ٲ  ڸƮ ش.

    WaitElevator(act);     //͸ ٸ
    ShowButtonState();      //ư¸ 

	if(act->GetDoorState() == OPEN && act->GetCurrent_floor() == level)//  
	{
		if(act->GetDirection() == UP || act->GetCurrent_floor() == 1)		//  ̸
		{
            button.CancleButton(UP);
		   	dir = ExtractDirection(UP);					//  ̸ 

        }
		else if(act->GetDirection() == DOWN || act->GetCurrent_floor() == FLOOR)//  Ʒ̸
		{
            button.CancleButton(DOWN);
			dir = ExtractDirection(DOWN);
        }
  	    act->RideElevator(dir);			//   ¿
	}
	else if(act->GetDoorState() == CLOSE)
	{
        WaitAndWork();				//ϴ  ϴ  ó
	}
}

void Floor::WaitAndWork(void)
{
	list<Person>::iterator i = wait.begin();   //ٸ ó

	while(i != wait.end())    //  ƴҶ
	{
		(*i).Wait();          //Person::Wait()ȣ
		i++;                  // 
	}

	i = work.begin();         //ϴ ó 

	while(i != work.end())    //  ƴҶ 
	{
		(*i).Work();          //Person::Work() ȣ
        if((*i).EndWork() == true)     //   ̸
        {
            (*i).ReWork();              //ٽ ϰŸ  ش
        }
		i++;
	}
}

list<Person> Floor::ExtractDirection(int dir)
{
	list<Person>::iterator i = wait.begin();   //ϴ Ʈ ó
	list<Person> temp;

	switch(dir)
	{
		case UP:
			while(i != wait.end())
			{
				if((*i).GetGoFloor() > level) //   
				{
					temp.push_back(*i);  //ӽ Ʈ 
					wait.erase(i++);     //⸮Ʈ 
                    wait_count--;        // ο 
                }
				else
					i++;
			}
			break;
		case DOWN:
			while(i != wait.end())
			{
				if((*i).GetGoFloor() < level) // Ʒ   
				{
					temp.push_back(*i);   //ӽ Ʈ 
					wait.erase(i++);      //ϴ Ʈ 
                    wait_count--;         //ϴ ο 
				}
				else
					i++;
			}
			break;
	}
	return temp;
}

void Floor::AddWaitElevator(void)
{
	list<Person>::iterator i = work.begin();

	while(i != work.end())
	{
        if((*i).GetGoFloor() != level) //  
        {                              // ٸ  
		    wait.push_back(*i);     // Ʈ 
            work.erase(i++);        //ϴ  Ʈ 
            wait_count++;           //ٸ  
            work_count--;           //ϴ  
        }
        else
		    i++;
    }
}


